/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <gnome.h>
#include "Interface/Root_Interface.h"
#include "Interface/Erreur_Interface.h"
#include "Debug.h"
#include "Reseau.h"
#include "Gconf.h"
#include "Quit.h"

void debug_printf (gint Id_Reseau, int Niveau_Debug, const char *file, const char *Fonction, int line, char *fmt, ...)
{
	if (Debug >= Niveau_Debug) {
		struct Struct_Liste_Reseau *Reseau = NULL;
		GtkWidget *Win_Info_User = NULL;
		va_list   args;
		gchar    *Message_Erreur;
		char      buffer[700];	

		va_start (args, fmt);
		vsnprintf (buffer, 700, fmt, args);
		switch (Niveau_Debug) {
		    case D_ERRO:
			    Id_Reseau_Erreur = Id_Reseau;
			    Reseau = Recupere_Pointeur_Structure_Reseau (Id_Reseau);
			    switch (Id_Reseau) {
				case INTERFACE:
					Message_Erreur = g_strdup_printf ("File : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", file, Fonction, line, buffer);
					break;
				case 0:
					Message_Erreur = g_strdup_printf ("Agent\nFile : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", file, Fonction, line, buffer);
					break;
				default:
					Message_Erreur = g_strdup_printf ("Agent : [%s]\nFile : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", Reseau->Nom_Reseau, file, Fonction, line, buffer);
			    }
			    gtk_label_set_text (GTK_LABEL (label_Erreur), Message_Erreur);
				g_free(Message_Erreur);
				gtk_widget_show(window_Erreur);
			    
			    break;
		    case D_WARN_USER:
			    if (Id_Reseau == INTERFACE)
				    Win_Info_User = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, "File : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", file, Fonction, line, buffer);
			    else {
				    if (Id_Reseau == 0)	
					    Win_Info_User = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, "Agent \nFile : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", file, Fonction, line, buffer);
				    else {
					    Reseau = Recupere_Pointeur_Structure_Reseau (Id_Reseau);
					    Win_Info_User = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, "Agent : [%s]\nFile : [%s]\nFonction : [%s]\nLine : [%d] \n\nMessage :\n%s", Reseau->Nom_Reseau, file, Fonction, line, buffer);
				    }
			    }
			    gtk_dialog_run (GTK_DIALOG (Win_Info_User));
			    gtk_widget_destroy (Win_Info_User);
			    break;
		    case D_WARN:
			    printf ("[I] [WARNING] [%s](%s:%d): %s\n", Fonction, file, line, buffer);
			    break;
		    case D_INFO_USER:
			    if (Id_Reseau == INTERFACE)
				    Win_Info_User = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, "%s", buffer);
			    else {
				    Reseau = Recupere_Pointeur_Structure_Reseau (Id_Reseau);
				    Win_Info_User = gtk_message_dialog_new (GTK_WINDOW (window_root), GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, "Agent : [%s]\n\n%s", Reseau->Nom_Reseau, buffer);
			    }
			    gtk_dialog_run (GTK_DIALOG (Win_Info_User));
			    gtk_widget_destroy (Win_Info_User);
			    break;
		    case D_INFO:
			    printf ("[I] [INFO] [%s]: %s\n", Fonction, buffer);
			    break;
		    case D_ALL:
			    printf ("[I] [ALL] [%s]:%s\n", Fonction, buffer);
			    break;
		    default:
			    printf ("[I] [?]  %s\n", buffer);
		}
		va_end (args);
	}
}


void Initialisation_Debug ()
{
	Debug = Lecture_Gconf_Int (INT_DEBUG);
}
