/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef         __EQUIPEMENT
#define         __EQUIPEMENT

#include <gnome.h>
#include <time.h>
#include "Reseau.h"
#include "crypt-md5.h"

#define NB_SCAN_OS 15
#define NUM_MAX_REGISTRATION 25
#define IP_ADDR_LEN	4
#define MAC_ADDR_LEN 6
#define REGISTRATION_GROUP 1
#define REGISTRATION_UNIQUE 2
#define PORT_TELNET 23
#define PORT_SSL 22
#define PORT_SAMBA 139

enum enum_Nessus {
	INFO_NIVEAU_NESSUS = 0,
	NOTE_NIVEAU_NESSUS,
	HOLE_NIVEAU_NESSUS
};

struct Struct_Nessus {
	gint      Niveau_Nessus;	
	gchar    *Info;
	gchar    *Texte;
};

struct struct_Reponse {
	unsigned char TaillePacketReponse;	
	
	unsigned char HeaderLengthIP;
	unsigned char DSF;
	unsigned short TailleTotal;
	unsigned char Id;	
	unsigned short Flags_IP_Offset;
	unsigned char TTL;
	
	unsigned char NumSeq;	
	unsigned char HeaderLengthTCP;
	unsigned char Flags_TCP;
	unsigned short WindowSize;
};


struct struct_Smb_Registration {
	unsigned char Type;	
	unsigned char Name[16 + 1];
	unsigned char Numero;
};

struct struct_Smb {
	unsigned char HostName[16 + 1];
	unsigned char DomainName[16 + 1];
	unsigned char Utilisateur[16 + 1];
	struct struct_Smb_Registration Smb_Registration[NUM_MAX_REGISTRATION];
};


struct Struct_Equipement {
	unsigned char ID_Equipement[MAC_ADDR_LEN + IP_ADDR_LEN + 1];	
	unsigned char Adresse_Ip_Char[15 + 1];	
	unsigned char Adresse_MAC_Char[17 + 1];	
	gboolean  Equipement_Allumer;	
	time_t    Derniere_Modification_Etat_Equipement;
	gboolean  Notification_En_Cours;	
	gboolean  Scan_Nessus_En_Cours;	
	GList    *GList_Port;	
	int       Nb_Port_Total_Scanner;
	int       Nb_Port_Ouvert;
	int       Nb_Port_Fermer;
	int       Nb_Port_Firewaller;
	struct struct_Reponse Reponse_Signature[NB_SCAN_OS];	
	gchar    *Debug_Signature;
	char     *Entete_FTP;
	char     *Entete_HTTP;
	char     *Entete_IMAP;
	char     *Entete_TELNET;
	gchar     Md5_Signature[32 + 1];	
	struct Struct_Signature *Signature;
	struct struct_Smb Smb;
	gchar    *User_Smb;
	gchar    *Password_Smb;
	gchar    *Partage_En_Cours;	
	gchar    *Chemin_Samba_En_Cours;	
	gchar    *Contact_Admin;
	gchar    *Localisation;
	gchar    *Num_Serie;
	gchar    *Num_Serie_Ecran;
	gchar    *Num_Serie_Imprimante;
	gchar    *Num_Serie_OS;
	gchar	 *Num_Serie_Office_Suite;
	gchar    *Processeur;
	gchar    *Memoire;
	gchar    *Disque;
	gchar    *Contact;
	gchar    *Tel_Contact;
	gchar    *Notes;
	GList    *GList_Nessus;
	struct Struct_Nessus *Nessus_En_Cours;	
	GList    *GList_Historique;
};

struct Struct_Equipement *Equipement_Selectionner;

struct Struct_Modele_Objet *Afficher_Nouveau_Equipement (struct Struct_Equipement *Equipement, gint ID_Reseau);
void      Retour_Info (gpointer * Donnee);
void      Retour_Alerte_Intrusion (gpointer * Donnee);
struct Struct_Modele_Objet *Recherche_Objet_Equipement (unsigned char *ID_Equipement, gint ID_Reseau);
void      Retour_Notification_Equipement (gpointer * Donnee);
void      Debug_ID_Equipement (unsigned char *ID_Equipement);
void      Parcours_Equipement_Inconnu (gchar * Signature);
gchar    *Debug_Signature_Equipement (struct Struct_Equipement *Equipement);
void      Copie_Icone_Equipement (gpointer * pointeur);
char     *url_encode (char *source);
void      Recuperation_Nouveau_Equipement (gpointer * Donnee);
void      Initialisation_Equipement ();
#endif
