/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <gnome.h>
#include "Debug.h"

GdkPixbuf *Chargement_Image (char *Chemin_Icone, gfloat saturation)
{
	GdkPixbuf *icone;
	GError   *error = NULL;

	ERROR_if (Chemin_Icone == NULL);
	icone = gdk_pixbuf_new_from_file (Chemin_Icone, &error);
	if (error) {
		debug_printf (INTERFACE, D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Could not load icon: %s\n", error->message);
		g_error_free (error);
		return NULL;
	}
	gdk_pixbuf_saturate_and_pixelate (icone, icone, saturation, FALSE);
	return icone;
}
