/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "Add_Network_Callbacks.h"
#include "Add_Network_Interface.h"
#include "Root_Interface.h"
#include "../Add_Network_Subnet.h"
#include "../Com/Initialisation_Com.h"
#include "../Execute.h"
#include "Combo.h"
#include "../Reseau.h"
#include "../Restoration_Agent.h"
#include "../Restoration_Interface.h"

void Modifie_Class_A ()
{
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_A, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_B, FALSE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_C, FALSE);
}

void Modifie_Class_B ()
{
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_A, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_B, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_C, FALSE);
}

void Modifie_Class_C ()
{
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_A, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_B, TRUE);
	gtk_widget_set_sensitive (spinbutton_Network_Private_Subnet_C, TRUE);
}


gboolean Add_Network_cancel (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	gtk_widget_hide (window_Add_Network);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestart_Add_Network));
	Pid_Agent_Initialisation = -1;
	return FALSE;
}


void on_druidpagestandard_Network_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{

}


gboolean on_druidpagestandard_Network_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Network_Restore)) && (strlen ((gchar *) gtk_entry_get_text (GTK_ENTRY (combo_entry_Network_Restore))) == 0))
		return TRUE;
	Enregistrement_Donnee_Xml_Subnet ();
	gtk_expander_set_expanded (GTK_EXPANDER (expander_Network_Private_Subnet), FALSE);
	return FALSE;
}


void Subnet_changed (GtkComboBox * combobox, gpointer user_data)
{
	if (!Liste_Subnet_Modification_Interface) {	
		gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, TRUE);
		gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, TRUE);
		gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
		gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, FALSE);
		Subnet_Modification = Subnet_Selectionner;
	}
}


void on_button_Network_Private_Subnet_Add_clicked (GtkButton * button, gpointer user_data)
{
	gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_Network_Private_Subnet), 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), (gfloat) 0);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, TRUE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, TRUE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, FALSE);
	gtk_widget_set_sensitive (combobox_Network_Private_Subnet, TRUE);
	Subnet_Modification = NULL;
	Subnet_Selectionner = NULL;
}


void on_button_Network_Private_Subnet_Delete_clicked (GtkButton * button, gpointer user_data)
{
	Supprime_Subnet_liste (Subnet_Selectionner);
	gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_Network_Private_Subnet), -1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), (gfloat) 0);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, TRUE);
	Subnet_Sensible (FALSE);
	Subnet_Modification = NULL;
	Subnet_Selectionner = NULL;
}


void on_button_Network_Private_Subnet_OK_clicked (GtkButton * button, gpointer user_data)
{
	Modifie_Ajoute_Nouveau_Subnet ();
	gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_Network_Private_Subnet), -1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), (gfloat) 0);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, TRUE);
	Subnet_Sensible (FALSE);
	Subnet_Modification = NULL;
	Subnet_Selectionner = NULL;
}


void on_button_Network_Private_Subnet_Cancel_clicked (GtkButton * button, gpointer user_data)
{
	gtk_combo_box_set_active (GTK_COMBO_BOX (combobox_Network_Private_Subnet), -1);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_A), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_B), (gfloat) 0);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Network_Private_Subnet_C), (gfloat) 0);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_OK, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Cancel, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Delete, FALSE);
	gtk_widget_set_sensitive (button_Network_Private_Subnet_Add, TRUE);
	Subnet_Sensible (FALSE);
	Subnet_Modification = NULL;
	Subnet_Selectionner = NULL;
}


void on_radiobutton_Select_Network_Restore_clicked (GtkButton * button, gpointer user_data)
{

}


void on_druidpagestandard_Localisation_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{

}


gboolean on_druidpagestandard_Localisation_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	Efface_Toute_Interface_Combo ();	
	
	gtk_progress_bar_set_text (GTK_PROGRESS_BAR (progressbar_Initialize), _("Connecting"));
	gtk_progress_bar_set_fraction (GTK_PROGRESS_BAR (progressbar_Initialize), 0);
	Agent_Initialiser = FALSE;
	Lance_Nouveau_Agent_Local ();
	return FALSE;
}


void on_radiobutton__Select_Network_Local_clicked (GtkButton * button, gpointer user_data)
{

}


void on_radiobutton_Select_Network_Connect_clicked (GtkButton * button, gpointer user_data)
{

}


void on_druidpagestandard_Initialize_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{

}


gboolean on_druidpagestandard_Initialize_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	return !Agent_Initialiser;
}


gboolean on_druidpagestandard_Initialize_back (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	Kill_Process_AutoScan_Agent ();
	return FALSE;
}


gboolean Add_Network_Destroy_Agent_cancel (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	Kill_Process_AutoScan_Agent ();
	gtk_widget_hide (window_Add_Network);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestart_Add_Network));
	Pid_Agent_Initialisation = -1;
	return FALSE;
}


gboolean on_druidpagestandard_Select_Interface_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	return FALSE;
}


void on_druidpagefinish_Add_Network_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
#define TEXTE "Confirm the following information: \n\nName Network : %s\nInterface : %s\n"
	gchar    *text, *combo, *Index_Fin_Nom_Reseau;

	combo = Recuperation_Texte_Combo (combobox_Select_Interface);
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Network_Restore))) {
		if ((Index_Fin_Nom_Reseau = index (Nom_Reseau_Restauration, '-')) != NULL)	
			Nom_Reseau_Restauration[Index_Fin_Nom_Reseau - Nom_Reseau_Restauration] = '\0';
		
		while (Nom_Reseau_Restauration[strlen (Nom_Reseau_Restauration) - 1] == 0x20) {
			Nom_Reseau_Restauration[strlen (Nom_Reseau_Restauration) - 1] = 0;
		}
		text = g_strdup_printf (TEXTE, Nom_Reseau_Restauration, combo);
	}
	else
		text = g_strdup_printf (TEXTE, gtk_entry_get_text (GTK_ENTRY (entry_Network_New_Name)), combo);
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_Network), text);
	g_free (combo);		
	g_free (text);
}


void on_druidpagefinish_Add_Network_finish (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
#define NOM_RESEAU "%s - %s"
	gchar    *Nom_Reseau, *combo;
	gint      ID_Reseau;

	combo = Recuperation_Texte_Combo (combobox_Select_Interface);
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Network_Restore)))
		Nom_Reseau = g_strdup_printf (NOM_RESEAU, Nom_Reseau_Restauration, combo);
	else
		Nom_Reseau = g_strdup_printf (NOM_RESEAU, gtk_entry_get_text (GTK_ENTRY (entry_Network_New_Name)), combo);
	ID_Reseau = Creation_Nouveau_Reseau (Nom_Reseau);
	gtk_widget_hide (window_Add_Network);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_Network), GNOME_DRUID_PAGE (druidpagestart_Add_Network));
	
	if ((ID_Reseau != -1) && (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Network_Restore))))	
		Restoration_Interface ((gchar *) gtk_entry_get_text (GTK_ENTRY (combo_entry_Network_Restore)), ID_Reseau);
	Pid_Agent_Initialisation = -1;
	g_free (combo);		
	g_free (Nom_Reseau);
	if (ID_Reseau != -1) {
		gtk_widget_set_sensitive (toolbutton_Save, TRUE);
		gtk_widget_set_sensitive (toolbutton_Search, TRUE);
		gtk_widget_set_sensitive (toggletoolbutton_Alert_Intrusion, TRUE);
	}
}


void on_window_Add_Network_destroy (GtkObject * object, gpointer user_data)
{
	if (Pid_Agent_Initialisation != -1)
		Kill_Process_AutoScan_Agent ();
	create_window_Add_Network ();
	Afficher_Liste_Subnet ();
}
