/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "Fingerprinting_Callbacks.h"
#include "Fingerprinting_Interface.h"
#include "../Objet.h"
#include "../Equipement.h"
#include "../Gconf.h"
#include "../Contribution.h"
#include "../Equipement.h"
#include "../Equipement_Port.h"
#include "../Settings_Signature.h"
#include "../Debug.h"
#include "Combo.h"


void on_Wizard_Add_OS_Fingerprinting_destroy (GtkObject * object, gpointer user_data)
{
	create_Wizard_Add_OS_Fingerprinting ();
}


gboolean Add_OS_Fingerprinting_cancel (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	gtk_widget_hide (Wizard_Add_OS_Fingerprinting);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestart_Add_OS_Fingerprinting));
	gtk_entry_set_text (GTK_ENTRY (entry_Information_OS_System_Name), "");
	return FALSE;
}


void on_druidpagestandard_Information_OS_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Prepare info OS : %s", Equipement_Selectionner->Adresse_Ip_Char);
	gtk_entry_set_text (GTK_ENTRY (entry_Information_MD5), Equipement_Selectionner->Md5_Signature);
	gnome_icon_entry_set_filename (GNOME_ICON_ENTRY (iconentry_Information_Icon), "/usr/share/pixmaps/AutoScan/Equipment/");
}

gboolean on_druidpagestandard_Information_OS_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	return (strlen (gtk_entry_get_text (GTK_ENTRY (entry_Information_OS_System_Name))) == 0);
}

gboolean on_druidpagestandard_Contribute_OS_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Contribute_OS_Not_Submit)))
		gnome_druid_set_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagefinish_Add_OS_Fingerprinting));
	return FALSE;
}


void on_druidpagestandard_Contribute_OS_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{

}


void on_druidpagestandard_Connection_Internet_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	if (strcmp (Lecture_Info_Conf_Char ("/system/proxy/mode"), "none") == 0) {
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_Direct_Connection), TRUE);
		gtk_widget_set_sensitive (spinbutton_Manual_Port, FALSE);
		gtk_widget_set_sensitive (entry_Manual_HTTP_Proxy, FALSE);
		gtk_widget_set_sensitive (entry_Automatic_URL, FALSE);
	}

	if (strcmp (Lecture_Info_Conf_Char ("/system/proxy/mode"), "manual") == 0) {
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_Manual_Connection), TRUE);
		gtk_widget_set_sensitive (spinbutton_Manual_Port, TRUE);
		gtk_widget_set_sensitive (entry_Manual_HTTP_Proxy, TRUE);
		gtk_widget_set_sensitive (entry_Automatic_URL, FALSE);
	}
	if (strcmp (Lecture_Info_Conf_Char ("/system/proxy/mode"), "auto") == 0) {
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_Automatic_Proxy), TRUE);
		gtk_widget_set_sensitive (spinbutton_Manual_Port, FALSE);
		gtk_widget_set_sensitive (entry_Manual_HTTP_Proxy, FALSE);
		gtk_widget_set_sensitive (entry_Automatic_URL, TRUE);
	}
	gtk_widget_set_sensitive (entry_User_Authentication, FALSE);
	gtk_widget_set_sensitive (entry_Password_Authentication, FALSE);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton_Authentication), Lecture_Info_Conf_Bool ("/system/http_proxy/use_authentication"));
	if (Lecture_Info_Conf_Bool ("/system/http_proxy/use_authentication")) {
		gtk_widget_set_sensitive (entry_User_Authentication, TRUE);
		gtk_widget_set_sensitive (entry_Password_Authentication, TRUE);
	}
	else {
		gtk_widget_set_sensitive (entry_User_Authentication, FALSE);
		gtk_widget_set_sensitive (entry_Password_Authentication, FALSE);
	}
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (spinbutton_Manual_Port), (gfloat) Lecture_Info_Conf_Int ("/system/http_proxy/port"));
	gtk_entry_set_text (GTK_ENTRY (entry_Manual_HTTP_Proxy), Lecture_Info_Conf_Char ("/system/http_proxy/host"));
	gtk_entry_set_text (GTK_ENTRY (entry_Automatic_URL), Lecture_Info_Conf_Char ("/system/proxy/autoconfig_url"));
	gtk_entry_set_text (GTK_ENTRY (entry_User_Authentication), Lecture_Info_Conf_Char ("/system/http_proxy/authentication_user"));
	gtk_entry_set_text (GTK_ENTRY (entry_Password_Authentication), Lecture_Info_Conf_Char ("/system/http_proxy/authentication_password"));
}


gboolean on_druidpagestandard_Connection_Internet_next (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Direct_Connection))) {
		Enregistrement_Info_Conf_Char ("/system/proxy/mode", "none");
		Enregistrement_Info_Conf_Bool ("/system/http_proxy/use_http_proxy", FALSE);
	}
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Manual_Connection))) {
		Enregistrement_Info_Conf_Char ("/system/proxy/mode", "manual");
		Enregistrement_Info_Conf_Bool ("/system/http_proxy/use_http_proxy", TRUE);
	}
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Automatic_Proxy))) {
		Enregistrement_Info_Conf_Char ("/system/proxy/mode", "auto");
		Enregistrement_Info_Conf_Bool ("/system/http_proxy/use_http_proxy", TRUE);
	}
	Enregistrement_Info_Conf_Char ("/system/http_proxy/host", (gchar *) gtk_entry_get_text (GTK_ENTRY (entry_Manual_HTTP_Proxy)));
	Enregistrement_Info_Conf_Char ("/system/proxy/autoconfig_url", (gchar *) gtk_entry_get_text (GTK_ENTRY (entry_Automatic_URL)));
	Enregistrement_Info_Conf_Char ("/system/http_proxy/authentication_user", (gchar *) gtk_entry_get_text (GTK_ENTRY (entry_User_Authentication)));
	Enregistrement_Info_Conf_Char ("/system/http_proxy/authentication_password", (gchar *) gtk_entry_get_text (GTK_ENTRY (entry_Password_Authentication)));
	Enregistrement_Info_Conf_Int ("/system/http_proxy/port", (gint) gtk_spin_button_get_value (GTK_SPIN_BUTTON (spinbutton_Manual_Port)));
	Enregistrement_Info_Conf_Bool ("/system/http_proxy/use_authentication", gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (checkbutton_Authentication)));
	return FALSE;
}


void on_radiobutton_General_Internet_Direct_New_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_set_sensitive (spinbutton_Manual_Port, FALSE);
	gtk_widget_set_sensitive (entry_Manual_HTTP_Proxy, FALSE);
	gtk_widget_set_sensitive (entry_Automatic_URL, FALSE);
}


void on_radiobutton_General_Internet_Http_Proxy_New_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_set_sensitive (spinbutton_Manual_Port, TRUE);
	gtk_widget_set_sensitive (entry_Manual_HTTP_Proxy, TRUE);
	gtk_widget_set_sensitive (entry_Automatic_URL, FALSE);
}


void on_radiobutton_General_Internet_Url_New_clicked (GtkButton * button, gpointer user_data)
{
	gtk_widget_set_sensitive (spinbutton_Manual_Port, FALSE);
	gtk_widget_set_sensitive (entry_Manual_HTTP_Proxy, FALSE);
	gtk_widget_set_sensitive (entry_Automatic_URL, TRUE);
}


void on_checkbutton_General_Internet_Authentication_New_clicked (GtkButton * button, gpointer user_data)
{
	debug_printf (INTERFACE, D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "toggle");
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (button))) {
		gtk_widget_set_sensitive (entry_Password_Authentication, TRUE);
		gtk_widget_set_sensitive (entry_User_Authentication, TRUE);
	}
	else {
		gtk_widget_set_sensitive (entry_Password_Authentication, FALSE);
		gtk_widget_set_sensitive (entry_User_Authentication, FALSE);
	}
}

void on_druidpagefinish_Add_OS_Fingerprinting_prepare (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
#define TEXTE "Confirm the following information: \n\nSystem Name : %s\nType : %s\n"
	gchar    *text, *combo;

	combo = Recuperation_Texte_Combo (combobox_Information_OS_Type);
	text = g_strdup_printf (TEXTE, gtk_entry_get_text (GTK_ENTRY (entry_Information_OS_System_Name)), combo);
	gnome_druid_page_edge_set_text (GNOME_DRUID_PAGE_EDGE (druidpagefinish_Add_OS_Fingerprinting), text);
	g_free (combo);		
	g_free (text);
}


void on_druidpagefinish_Add_OS_Fingerprinting_finish (GnomeDruidPage * gnomedruidpage, GtkWidget * widget, gpointer user_data)
{
	char     *debug, *combo;


	Rajouter_Nouvelle_Signature ((gchar *) gtk_entry_get_text (GTK_ENTRY (entry_Information_OS_System_Name)), Equipement_Selectionner->Md5_Signature, gtk_combo_box_get_active (GTK_COMBO_BOX (combobox_Information_OS_Type)), gnome_icon_entry_get_filename (GNOME_ICON_ENTRY (iconentry_Information_Icon)), Equipement_Selectionner->Entete_FTP, Equipement_Selectionner->Entete_HTTP, Equipement_Selectionner->Entete_IMAP, Equipement_Selectionner->Entete_TELNET);
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (radiobutton_Contribute_OS_Submit))) {
		debug = url_encode (Equipement_Selectionner->Debug_Signature);
		combo = Recuperation_Texte_Combo (combobox_Information_OS_Type);
		contribution ((gchar *) gtk_entry_get_text (GTK_ENTRY (entry_Information_OS_System_Name)), Equipement_Selectionner->Md5_Signature, combo, Equipement_Selectionner->Nb_Port_Ouvert, Equipement_Selectionner->Adresse_MAC_Char, Cherche_Si_Port_Ouvert (Equipement_Selectionner, PORT_FTP), (char) Cherche_Si_Port_Ouvert (Equipement_Selectionner, PORT_HTTP), (char) Cherche_Si_Port_Ouvert (Equipement_Selectionner, PORT_IMAP), (char) Cherche_Si_Port_Ouvert (Equipement_Selectionner, PORT_TELNET), (char) Cherche_Si_Port_Ouvert (Equipement_Selectionner, PORT_SPOOLER), Equipement_Selectionner->Entete_FTP, Equipement_Selectionner->Entete_HTTP, Equipement_Selectionner->Entete_IMAP, Equipement_Selectionner->Entete_TELNET, debug);
		free (debug);
		g_free (combo);	
	}
	gtk_widget_hide (Wizard_Add_OS_Fingerprinting);
	gnome_druid_set_page (GNOME_DRUID (druid_Add_OS_Fingerprinting), GNOME_DRUID_PAGE (druidpagestart_Add_OS_Fingerprinting));
	gtk_entry_set_text (GTK_ENTRY (entry_Information_OS_System_Name), "");
	Parcours_Equipement_Inconnu (Equipement_Selectionner->Md5_Signature);
}
