/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <gnome.h>
#include "Objet.h"
#include "Reseau.h"
#include "Interface/Root_Interface.h"
#include "Interface/Fingerprinting_Interface.h"
#include "Interface/Combo.h"
#include "Debug.h"
#include "Equipement_Port.h"
#include "Equipement_Historique.h"
#include "Modules.h"
#include "Com/Commun.h"
#include "Equipement_Nessus.h"
#include "Objet_Liste.h"

void Action_Test_Favoris (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Favoris sur l'objet (%s)   [%p]", Objet->Texte_Defaut, Objet);
	Objet->Favoris = !Objet->Favoris;
}


void Action_Test_Raffraichir (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Rafraichir sur l'objet (%s)", Objet->Texte_Defaut);
	Active_Rachaichissment_Objet (Objet, Reseau);
	Afficher_Liste (Reseau->GList_Rafraichissement);
}


void Notification_Port (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Port *Port_Equipement = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct struct_Demande_Notication_Critique_Etat_Port Message;
	struct struct_Annulation_Notification_Etat_Port Message_Annulation;

	ERROR_if (pointer == NULL);
	Port_Equipement = (struct Struct_Port *) Objet->Pointeur_Attacher;
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Notification_Port sur l'objet (%s)   [%p]   [%s]:[%d]", Objet->Texte_Defaut, Objet, Equipement_Selectionner->Adresse_Ip_Char, Port_Equipement->Num_Port);
	if (gtk_toggle_tool_button_get_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification))) {
		Objet->Notification_En_Cours = TRUE;
		Port_Equipement->Notification_En_Cours = TRUE;
		bzero (&Message, sizeof (struct struct_Demande_Notication_Critique_Etat_Port));
		Message.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement_Selectionner->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message.Num_Port = Port_Equipement->Num_Port;
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_NOTIFICATION_CRITIQUE_ETAT_PORT, (gpointer *) & Message, sizeof (Message), Reseau);
	}
	else {
		Objet->Notification_En_Cours = FALSE;
		Port_Equipement->Notification_En_Cours = FALSE;
		bzero (&Message_Annulation, sizeof (struct struct_Annulation_Notification_Etat_Port));
		Message_Annulation.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message_Annulation.ID_Equipement, Equipement_Selectionner->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Message_Annulation.Num_Port = Port_Equipement->Num_Port;
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, ANNULATION_NOTIFICATION_ETAT_PORT, (gpointer *) & Message_Annulation, sizeof (Message_Annulation), Reseau);
	}
}


void Notification_Equipement (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct struct_Demande_Notication_Critique_Etat_Equipement Message;
	struct struct_Annulation_Notification_Etat_Equipement Message_Annulation;

	ERROR_if (pointer == NULL);
	Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Notification_Equipement sur l'objet (%s)   [%p]   [%s]", Objet->Texte_Defaut, Objet, Equipement->Adresse_Ip_Char);
	if (gtk_toggle_tool_button_get_active (GTK_TOGGLE_TOOL_BUTTON (toggletoolbutton_Notification))) {
		Objet->Notification_En_Cours = TRUE;
		Equipement->Notification_En_Cours = TRUE;
		bzero (&Message, sizeof (struct struct_Demande_Notication_Critique_Etat_Equipement));
		Message.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, DEMANDE_NOTIFICATION_CRITIQUE_ETAT_EQUIPEMENT, (gpointer *) & Message, sizeof (Message), Reseau);
	}
	else {
		Objet->Notification_En_Cours = FALSE;
		Equipement->Notification_En_Cours = FALSE;
		bzero (&Message_Annulation, sizeof (struct struct_Annulation_Notification_Etat_Equipement));
		Message_Annulation.ID_Reseau = Objet->ID_Reseau;
		memcpy (Message_Annulation.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Communication_Envoie_Donnee (Reseau->Pid_Agent, ANNULATION_NOTIFICATION_ETAT_EQUIPEMENT, (gpointer *) & Message_Annulation, sizeof (Message_Annulation), Reseau);
	}
}


void Action_Test_Notification (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;

	ERROR_if (pointer == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click Notification sur l'objet (%s)   [%p]", Objet->Texte_Defaut, Objet);
	Objet->Notification_En_Cours = !Objet->Notification_En_Cours;
}


void Action_Test_Click (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Selection sur l'objet (%s)   donnee [%p]", Objet->Texte_Defaut, Objet->Pointeur_Attacher);
}


void Action_Selection_Equipement_Inconnu (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Equipement *Equipement = NULL;

	ERROR_if (pointer == NULL);
	Action_Selection_Equipement (pointer);
	Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
	if (Equipement->Nb_Port_Ouvert != 0)
		gtk_widget_show (Wizard_Add_OS_Fingerprinting);
}

void Action_Selection_Type_OU_Domaine (gpointer * pointer)
{
	Equipement_Selectionner = NULL;
	Objet_Equipement_Selectionner = NULL;
	Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);	
	gtk_widget_set_sensitive (combobox_liste_Modules, FALSE);
	gtk_widget_set_sensitive (button_Refresh, FALSE);
	Initialisation_Aucun_Module ();
}

void Action_Selection_Equipement (gpointer * pointer)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Modele_Objet *Objet_Nessus;
	struct Struct_Liste_Reseau *Reseau = NULL;
	struct Struct_Equipement *Equipement = NULL;
	struct Struct_Historique *Historique = NULL;
	struct Struct_Nessus *Nessus = NULL;
	gint      i, Nb_Objet_Liste;
	gchar     Texte_Registration_Netbios[100];	
	gchar     Date[30], *Chaine_Historique = NULL;

	ERROR_if (pointer == NULL);
	if (Objet_Equipement_Selectionner != Objet) {	
		gtk_widget_set_sensitive (combobox_liste_Modules, TRUE);
		gtk_widget_set_sensitive (button_Refresh, TRUE);
		Objet_Equipement_Selectionner = Objet;
		Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
		Equipement = (struct Struct_Equipement *) Objet->Pointeur_Attacher;
		Equipement_Selectionner = Equipement;
		Efface_Toute_Objet_Liste (Reseau_Selectionner, LISTE_INFO);	
		Ajouter_Nouvelle_Objet (INFO_ADRESSE_IP, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_ADRESSE_MAC, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_FOURNISSEUR, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_OS, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (strlen (Equipement->Smb.HostName) != 0)
			Ajouter_Nouvelle_Objet (INFO_NOM_HOTE, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		if (strlen (Equipement->Smb.DomainName) != 0) {
			Ajouter_Nouvelle_Objet (INFO_NOM_UTILISATEUR, NULL, NULL, NULL, INFO_NOM_DOMAINE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			i = 0;
			while ((i < NUM_MAX_REGISTRATION) && (Equipement->Smb.Smb_Registration[i].Type != 0)) {
				sprintf (Texte_Registration_Netbios, "%s <%02X>", Equipement->Smb.Smb_Registration[i].Name, Equipement->Smb.Smb_Registration[i].Numero);
				if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
					strcat (Texte_Registration_Netbios, "GROUP ");
				if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
					strcat (Texte_Registration_Netbios, "UNIQUE ");
				switch (Equipement->Smb.Smb_Registration[i].Numero) {
				    case 0x00:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
						    strcat (Texte_Registration_Netbios, " Workstation Service");
					    else
						    strcat (Texte_Registration_Netbios, " Domain Name");
					    break;
				    case 0x01:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_UNIQUE)
						    strcat (Texte_Registration_Netbios, " Messenger Service");
					    else
						    strcat (Texte_Registration_Netbios, " Master Browser");
					    break;
				    case 0x03:
					    strcat (Texte_Registration_Netbios, " Messenger Service");
					    break;
				    case 0x06:
					    strcat (Texte_Registration_Netbios, " RAS Server Service");
					    break;
				    case 0x1b:
					    strcat (Texte_Registration_Netbios, " Domain Master Browser");
					    break;
				    case 0x1c:
					    strcat (Texte_Registration_Netbios, " Domain Controllers");
					    break;
				    case 0x1d:
					    strcat (Texte_Registration_Netbios, " Master Browser");
					    break;
				    case 0x1e:
					    if (Equipement->Smb.Smb_Registration[i].Type == REGISTRATION_GROUP)
						    strcat (Texte_Registration_Netbios, " Browser Service Elections");
					    break;
				    case 0x1F:
					    strcat (Texte_Registration_Netbios, " NetDDE Service");
					    break;
				    case 0x20:
					    strcat (Texte_Registration_Netbios, " File Server Service");
					    break;
				    case 0x21:
					    strcat (Texte_Registration_Netbios, " RAS Client Service");
					    break;
				    case 0x22:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Interchange(MSMail Connector)");
					    break;
				    case 0x23:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Store");
					    break;
				    case 0x24:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange Directory");
					    break;
				    case 0x30:
					    strcat (Texte_Registration_Netbios, " Modem Sharing Server Service");
					    break;
				    case 0x31:
					    strcat (Texte_Registration_Netbios, " Modem Sharing Client Service");
					    break;
				    case 0x42:
					    strcat (Texte_Registration_Netbios, " Mcaffee Anti-Virus");
					    break;
				    case 0x43:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Control");
					    break;
				    case 0x44:
					    strcat (Texte_Registration_Netbios, " SMS Administrators Remote Control Tool");
					    break;
				    case 0x45:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Chat");
					    break;
				    case 0x46:
					    strcat (Texte_Registration_Netbios, " SMS Clients Remote Transfer");
					    break;
				    case 0x4C:
					    strcat (Texte_Registration_Netbios, " DEC Pathworks TCPIP service on Windows NT");
					    break;
				    case 0x52:
					    strcat (Texte_Registration_Netbios, " DEC Pathworks TCPIP service on Windows NT");
					    break;
				    case 0x6a:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange IMC");
					    break;
				    case 0x87:
					    strcat (Texte_Registration_Netbios, " Microsoft Exchange MTA");
					    break;
				    case 0xbe:
					    strcat (Texte_Registration_Netbios, " Network Monitor Agent");
					    break;
				    case 0xbf:
					    strcat (Texte_Registration_Netbios, " Network Monitor Application");
					    break;
				    default:
					    strcat (Texte_Registration_Netbios, " Unknown");
					    break;
				}
				Ajouter_Nouvelle_Objet (INFO_NETBIOS_ENFANT, Texte_Registration_Netbios, NULL, NULL, INFO_NETBIOS, NULL, INFO_NOM_DOMAINE, ID_Reseau_En_Cours, LISTE_INFO);
				i++;
			}
		}
		Ajouter_Nouvelle_Objet (INFO_PORTS, NULL, NULL, NULL, INFO_INFO, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_CONTACT_ADMIN, NULL, (gpointer *) & Equipement->Contact_Admin, NULL, INFO_INFO, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_CONTACT, NULL, (gpointer *) & Equipement->Contact, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_TEL_CONTACT, NULL, (gpointer *) & Equipement->Tel_Contact, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_LOCALISATION, NULL, (gpointer *) & Equipement->Localisation, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE, NULL, (gpointer *) & Equipement->Num_Serie, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_ECRAN, NULL, (gpointer *) & Equipement->Num_Serie_Ecran, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_IMPRIMANTE, NULL, (gpointer *) & Equipement->Num_Serie_Imprimante, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_OS, NULL, (gpointer *) & Equipement->Num_Serie_OS, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NUM_SERIE_SUITE_OFFICE, NULL, (gpointer *) & Equipement->Num_Serie_Office_Suite, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_PROCESSEUR, NULL, (gpointer *) & Equipement->Processeur, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_MEMOIRE, NULL, (gpointer *) & Equipement->Memoire, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_DISQUE, NULL, (gpointer *) & Equipement->Disque, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Ajouter_Nouvelle_Objet (INFO_INVENTAIRE_NOTES, NULL, (gpointer *) & Equipement->Notes, NULL, INFO_INVENTAIRE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);

		Ajouter_Nouvelle_Objet (INFO_DERNIER_CHANGEMENT, NULL, NULL, NULL, INFO_INFO, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
		Nb_Objet_Liste = g_list_length (Equipement->GList_Historique);
		for (i = 0; i < Nb_Objet_Liste; i++) {
			Historique = g_list_nth_data (Equipement->GList_Historique, i);
			ctime_r (&Historique->Date, Date);
			Date[strlen (Date) - 1] = '\0';	
			Chaine_Historique = g_strdup_printf ("%s - %s", Date, Historique->Historique);
			switch (Historique->Niveau_Historique) {
			    case HISTORIQUE_INFO:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_INFO, Chaine_Historique, NULL, NULL, INFO_HISTORIQUE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    case HISTORIQUE_WARNING:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_WARNING, Chaine_Historique, NULL, NULL, INFO_HISTORIQUE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    case HISTORIQUE_ALERTE:
				    Ajouter_Nouvelle_Objet (INFO_HISTORIQUE_ALERTE, Chaine_Historique, NULL, NULL, INFO_HISTORIQUE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    default:
				    debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Type Historique Inconnu");
			}
			g_free (Chaine_Historique);
		}
		if (Equipement->Scan_Nessus_En_Cours) {
			Objet_Nessus = Ajouter_Nouvelle_Objet (INFO_NESSUS, NULL, NULL, NULL, PERE_RACINE, NULL, PERE_RACINE, ID_Reseau_En_Cours, LISTE_INFO);
			Objet_Nessus->Nb_Enfant = 0;	
			if (Objet_Nessus != NULL)
				Active_Rachaichissment_Objet (Objet_Nessus, Reseau);
		}
		
		Nb_Objet_Liste = g_list_length (Equipement->GList_Nessus);
		for (i = 0; i < Nb_Objet_Liste; i++) {
			Nessus = g_list_nth_data (Equipement->GList_Nessus, i);
			switch (Nessus->Niveau_Nessus) {
			    case INFO_NIVEAU_NESSUS:
				    Ajouter_Nouvelle_Objet (INFO_NESSUS_ENFANT_INFO, Nessus->Info, NULL, NULL, INFO_NESSUS_INFO, NULL, INFO_NESSUS, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    case NOTE_NIVEAU_NESSUS:
				    Ajouter_Nouvelle_Objet (INFO_NESSUS_ENFANT_POTENTIEL, Nessus->Info, NULL, NULL, INFO_NESSUS_POTENTIEL, NULL, INFO_NESSUS, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    case HOLE_NIVEAU_NESSUS:
				    Ajouter_Nouvelle_Objet (INFO_NESSUS_ENFANT_VULNERABILITE, Nessus->Info, NULL, NULL, INFO_NESSUS_VULNERABILITE, NULL, INFO_NESSUS, ID_Reseau_En_Cours, LISTE_INFO);
				    break;
			    default:
				    debug_printf (INTERFACE, D_ERRO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Type Nessus Inconnu");
			}
		}
		
		Efface_Combo (combobox_liste_Modules);
		creation_combo_milieu ();	
	}
}


void Edit_Texte_Liste_Machine (gpointer * pointer, gchar * NewTexte)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	GtkTreeModel *model = NULL;

	ERROR_if (pointer == NULL);
	ERROR_if (NewTexte == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Edit_Texte_Liste_Machine");
	
	if (Objet->Chaine_Attacher == NULL)
		return;		
	if (Objet->Pointeur_Attacher == NULL)
		return;		
	if (strncmp (Objet->Chaine_Attacher, NewTexte, strlen (Objet->Chaine_Attacher)) != 0) {
		debug_printf (INTERFACE, D_INFO_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Syntaxe error");
		return;
	}
	
	
	if (*Objet->Pointeur_Attacher != NULL)
		g_free (*Objet->Pointeur_Attacher);
	
	*Objet->Pointeur_Attacher = g_strdup (NewTexte + strlen (Objet->Chaine_Attacher));
	g_free (Objet->Texte_Defaut);
	Objet->Texte_Defaut = g_strdup (NewTexte);
	
	model = gtk_tree_view_get_model (GTK_TREE_VIEW (treeview_Info));
	gtk_tree_store_set (GTK_TREE_STORE (model), &Objet->ID_Arbre_Ligne, COL_TEXT, NewTexte, -1);

}


void Action_Click_Droit (gpointer * pointer, GdkEventButton * bev)
{
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct Struct_Liste_Reseau *Reseau = NULL;

	ERROR_if (pointer == NULL);
	Reseau = Recupere_Pointeur_Structure_Reseau (ID_Reseau_En_Cours);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Click droit sur l'objet (%s)", Objet->Texte_Defaut);
	Desactive_Rachaichissment_Objet (Objet, Reseau, TRUE);
	Afficher_Liste (Reseau->GList_Rafraichissement);
}
