/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "Objet_Gestion_Texte.h"
#include "Objet.h"
#include "Equipement.h"
#include "Settings_Signature.h"
#include "Fournisseur.h"
#include "Debug.h"

gchar    *Gestion_Texte_IP_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Adresse_Ip_Char);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Equipement->Adresse_Ip_Char) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Mac_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Adresse_MAC_Char);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Equipement->Adresse_MAC_Char) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Fournisseur_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	struct struct_MacListe *Mac = NULL;
	gchar    *Nouveau_Texte = NULL, *Fournisseur = NULL;
	gint      i, Nb_Objet_Liste;

	ERROR_if (pointer == NULL);
	i = 0;
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Recherche Fabricant");
	Nb_Objet_Liste = g_list_length (GList_Fournisseur);
	while ((i < Nb_Objet_Liste) && (Fournisseur == NULL)) {
		Mac = g_list_nth_data (GList_Fournisseur, i);
		if (strncmp (Mac->MAC, Equipement->Adresse_MAC_Char, 8) == 0) {
			Fournisseur = Mac->Constructeur;
		}
		i++;
	}
	if (Fournisseur == NULL)	
		Fournisseur = "???";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Fournisseur);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Fournisseur) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Syteme_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *System = NULL;

	ERROR_if (pointer == NULL);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Recherche system");
	if (Equipement->Signature != NULL)
		System = Equipement->Signature->System_Name;
	if (System == NULL){	
		if (Equipement->Nb_Port_Ouvert != 0)
			System = "Unknow equipment";
		else
			System = "Failed (no port open)";
	}
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, System);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (System) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Port_Info_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;

	ERROR_if (pointer == NULL);
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Equipement->Nb_Port_Ouvert, Equipement->Nb_Port_Total_Scanner, Equipement->Nb_Port_Firewaller, Equipement->Nb_Port_Total_Scanner);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + 12 + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Contact_Admin_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Contact_Admin = NULL;

	ERROR_if (pointer == NULL);
	Contact_Admin = Equipement->Contact_Admin;
	if (Contact_Admin == NULL)	
		Contact_Admin = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Contact_Admin);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Contact_Admin) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Localisation_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Localisation = NULL;

	ERROR_if (pointer == NULL);
	Localisation = Equipement->Localisation;
	if (Localisation == NULL)	
		Localisation = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Localisation);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Localisation) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Notes_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Notes = NULL;

	ERROR_if (pointer == NULL);
	Notes = Equipement->Notes;
	if (Notes == NULL)	
		Notes = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Notes);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Notes) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}
	

gchar    *Gestion_Texte_Num_Serie_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Num_Serie = NULL;

	ERROR_if (pointer == NULL);
	Num_Serie = Equipement->Num_Serie;
	if (Num_Serie == NULL)	
		Num_Serie = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Num_Serie);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Num_Serie) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Num_Serie_Ecran_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Num_Serie_Ecran = NULL;

	ERROR_if (pointer == NULL);
	Num_Serie_Ecran = Equipement->Num_Serie_Ecran;
	if (Num_Serie_Ecran == NULL)	
		Num_Serie_Ecran = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Num_Serie_Ecran);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Num_Serie_Ecran) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Num_Serie_Imprimante_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Num_Serie_Imprimante = NULL;

	ERROR_if (pointer == NULL);
	Num_Serie_Imprimante = Equipement->Num_Serie_Imprimante;
	if (Num_Serie_Imprimante == NULL)	
		Num_Serie_Imprimante = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Num_Serie_Imprimante);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Num_Serie_Imprimante) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}
	
gchar    *Gestion_Texte_Num_Serie_OS (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Num_Serie_OS = NULL;

	ERROR_if (pointer == NULL);
	Num_Serie_OS = Equipement->Num_Serie_OS;
	if (Num_Serie_OS == NULL)	
		Num_Serie_OS = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Num_Serie_OS);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Num_Serie_OS) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}
	

gchar    *Gestion_Texte_Num_Serie_Office_Suite (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Num_Serie_Office_Suite = NULL;

	ERROR_if (pointer == NULL);
	Num_Serie_Office_Suite = Equipement->Num_Serie_Office_Suite;
	if (Num_Serie_Office_Suite == NULL)	
		Num_Serie_Office_Suite = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Num_Serie_Office_Suite);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Num_Serie_Office_Suite) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Processeur_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Processeur = NULL;

	ERROR_if (pointer == NULL);
	Processeur = Equipement->Processeur;
	if (Processeur == NULL)	
		Processeur = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Processeur);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Processeur) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Memoire_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Memoire = NULL;

	ERROR_if (pointer == NULL);
	Memoire = Equipement->Memoire;
	if (Memoire == NULL)	
		Memoire = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Memoire);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Memoire) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}
	

gchar    *Gestion_Texte_Disque_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Disque = NULL;

	ERROR_if (pointer == NULL);
	Disque = Equipement->Disque;
	if (Disque == NULL)	
		Disque = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Disque);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Disque) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}

gchar    *Gestion_Texte_Contact_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Contact = NULL;

	ERROR_if (pointer == NULL);
	Contact = Equipement->Contact;
	if (Contact == NULL)	
		Contact = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Contact);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Contact) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}
	

gchar    *Gestion_Texte_Num_Contact_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Num_Contact = NULL;

	ERROR_if (pointer == NULL);
	Num_Contact = Equipement->Tel_Contact;
	if (Num_Contact == NULL)	
		Num_Contact = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Num_Contact);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Num_Contact) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}
	


	
gchar    *Gestion_Texte_Dernier_Changement_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL;
	gchar     Date[30];

	ERROR_if (pointer == NULL);
	ctime_r (&Equipement->Derniere_Modification_Etat_Equipement, Date);
	Date[strlen (Date) - 1] = '\0';	
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Date);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]   [%s][%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Date) + 1), Nouveau_Texte, Objet->Texte_Defaut, Date);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_HostName_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *HostName = NULL;

	ERROR_if (pointer == NULL);
	HostName = Equipement->Smb.HostName;
	if (HostName == NULL)	
		HostName = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, HostName);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (HostName) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Domaine_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Domaine = NULL;

	ERROR_if (pointer == NULL);
	Domaine = Equipement->Smb.DomainName;
	if (Domaine == NULL)	
		Domaine = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Domaine);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Domaine) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}


gchar    *Gestion_Texte_Utilisateur_Equipement (gpointer * pointer)
{
	struct Struct_Equipement *Equipement = (struct Struct_Equipement *) Objet_Equipement_Selectionner->Pointeur_Attacher;
	struct Struct_Modele_Objet *Objet = (struct Struct_Modele_Objet *) pointer;
	gchar    *Nouveau_Texte = NULL, *Utilisateur = NULL;

	ERROR_if (pointer == NULL);
	Utilisateur = Equipement->Smb.Utilisateur;
	if (Utilisateur == NULL)	
		Utilisateur = "none";
	Nouveau_Texte = g_strdup_printf (Objet->Texte_Defaut, Utilisateur);
	debug_printf (INTERFACE, D_ALL, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Gestion texte Equipement %s  Taille [%d]   [%s]", Equipement->Adresse_Ip_Char, (sizeof (gchar)) * (strlen (Objet->Texte_Defaut) + strlen (Utilisateur) + 1), Nouveau_Texte);
	return Nouveau_Texte;
}
