/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "Script.h"
#include "Debug.h"
#include "Com/Communication.h"
#include "Com/Commun.h"
#include "main.h"
#include "Interface/Script_Interface.h"
#include "Animation.h"
#include "Modules.h"


void Retour_Script (gpointer * Donnee)
{
	struct struct_Retour_Script *Message = (struct struct_Retour_Script *) Donnee;
	GtkTextBuffer *buffer = NULL;
	GtkTextIter iter;

	ERROR_if (Donnee == NULL);
	if ((Modules_Actuel == MODULES_SCRIPTS) && (Message->Equipement_Script == (gpointer *) Equipement_Selectionner)) {
		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textview_Script));
		gtk_text_buffer_get_end_iter (buffer, &iter);
		gtk_text_buffer_insert (buffer, &iter, (const gchar *) Message->Retour_Console, -1);
		refresh ();
		gtk_text_buffer_get_iter_at_offset (buffer, &iter, -1);
		gtk_text_view_scroll_to_iter (GTK_TEXT_VIEW (textview_Script), &iter, 0, FALSE, 0, 0);
		refresh ();
	}

}


void Retour_Script_Terminer (gpointer * Donnee)
{
#define Message_Fin "**********************************************************"
	struct struct_Retour_Script_Terminer *Message = (struct struct_Retour_Script_Terminer *) Donnee;
	GtkTextBuffer *buffer = NULL;
	GtkTextIter iter;

	ERROR_if (Donnee == NULL);
	if ((Modules_Actuel == MODULES_SCRIPTS) && (Message->Equipement_Script == (gpointer *) Equipement_Selectionner)) {
		buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textview_Script));
		gtk_text_buffer_get_end_iter (buffer, &iter);
		gtk_text_buffer_insert (buffer, &iter, (const gchar *) Message_Fin, -1);
		refresh ();
		gtk_text_buffer_get_iter_at_offset (buffer, &iter, -1);
		gtk_text_view_scroll_to_iter (GTK_TEXT_VIEW (textview_Script), &iter, 0, FALSE, 0, 0);
		refresh ();
	}
}


void Executer_Script (gchar * script, struct Struct_Equipement *Equipement)
{
	GtkTextBuffer *buffer = NULL;
	gchar     ligne[255];
	GtkTextIter iter;
	gint      Taille, pid_fils;

	ERROR_if (script == NULL);
	ERROR_if (Equipement == NULL);
	Taille = index (script, ' ') - script;
	strncpy (ligne, script, Taille);
	ligne[Taille] = '\0';
	if (!g_file_exists (ligne)) {	
		debug_printf (INTERFACE, D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Error loading executable : [%s]\n", ligne);
		return;
	}
	sprintf (ligne, "\n*******  Run : [%s] *****************************\n", script);
	buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (textview_Script));
	gtk_text_buffer_get_end_iter (buffer, &iter);
	gtk_text_buffer_insert (buffer, &iter, (const gchar *) ligne, -1);
	refresh ();
	gtk_text_buffer_get_iter_at_offset (buffer, &iter, -1);
	gtk_text_view_scroll_to_iter (GTK_TEXT_VIEW (textview_Script), &iter, 0, FALSE, 0, 0);
	refresh ();
	pid_fils = fork ();	
	if (pid_fils == 0) {
		struct struct_Retour_Script Message_Retour;
		struct struct_Retour_Script_Terminer Message_Retour_Terminer;
		FILE     *sortie;
		gchar     command[255], Ncommand[255], *pVariable;

#define VARIABLE_IP "_IP_"
#define VARIABLE_MAC "_MAC_"

		strcpy (command, script);
		if ((pVariable = strstr (command, VARIABLE_IP)) != 0) {
			strncpy (Ncommand, command, pVariable - command);
			Ncommand[pVariable - command] = '\0';
			strcat (Ncommand, Equipement->Adresse_Ip_Char);
			strcat (Ncommand, pVariable + strlen (VARIABLE_IP));
			strcpy (command, Ncommand);
		}

		if ((pVariable = strstr (command, VARIABLE_MAC)) != 0) {
			strncpy (Ncommand, command, pVariable - command);
			Ncommand[pVariable - command] = '\0';
			strcat (Ncommand, Equipement->Adresse_MAC_Char);
			strcat (Ncommand, pVariable + strlen (VARIABLE_MAC));
			strcpy (command, Ncommand);
		}

		if ((sortie = popen (command, "r")) == NULL) {
			printf ("popen  : %s", strerror (errno));	
			exit (127);
		}

		while (fgets (ligne, 254, sortie) != NULL) {
			Taille = strlen (ligne);
			strncpy (Message_Retour.Retour_Console, ligne, Taille);
			Message_Retour.Retour_Console[Taille] = 0;
			Message_Retour.Equipement_Script = (gpointer *) Equipement;
			Communication_Envoie_Donnee (Pid_AutoScan, RETOUR_SCRIPT, (gpointer *) & Message_Retour, sizeof (Message_Retour), NULL);
		}
		pclose (sortie);
		Message_Retour_Terminer.Equipement_Script = (gpointer *) Equipement;
		Communication_Envoie_Donnee (Pid_AutoScan, RETOUR_SCRIPT_TERMINER, (gpointer *) & Message_Retour_Terminer, sizeof (Message_Retour_Terminer), NULL);
		exit (127);
	}
}
