/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */




#ifndef md5_INCLUDED
#  define md5_INCLUDED



typedef unsigned char md5_byte_t; 
typedef unsigned int md5_word_t; 


typedef struct md5_state_s {
    md5_word_t count[2];	
    md5_word_t abcd[4];		
    md5_byte_t buf[64];		
} md5_state_t;

#ifdef __cplusplus
extern "C" 
{
#endif


void md5_init(md5_state_t *pms);


void md5_append(md5_state_t *pms, const md5_byte_t *data, int nbytes);


void md5_finish(md5_state_t *pms, md5_byte_t digest[16]);

#ifdef __cplusplus
}  
#endif

#endif 
