/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef         __DEBUG
#define         __DEBUG

enum enum_Niveau_Debug {
	D_ERRO = 0,
	D_WARN_USER,
	D_WARN,
	D_INFO_USER,
	D_INFO,
	D_ALL
};
int       Debug;

void      debug_printf (int Niveau_Debug, const char *file, const char *Fonction, int line, char *fmt, ...);
void      Initialisation_Debug ();

#define ERROR_if(expr)	G_STMT_START{			\
     if (expr)									\
       {										\
		debug_printf(D_ERRO			\
		,__FILE__,__PRETTY_FUNCTION__,__LINE__  \
		,"`%s' failed.",#expr);  				\
       };									}G_STMT_END


	   
#define return_WARNING_if(expr,val)	G_STMT_START{	\
     if (expr)										\
       {											\
		debug_printf(D_WARN				\
		,__FILE__,__PRETTY_FUNCTION__,__LINE__		\
		,"`%s' failed.",#expr);  					\
	 	return val;									\
       };									}G_STMT_END

#endif
