/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef         __LISTE_EQUIPEMENT
#define         __LISTE_EQUIPEMENT

#include <gnome.h>
#include <time.h>
#include "Reseau.h"

#define NB_SCAN_OS 15
#define NUM_MAX_REGISTRATION 25

struct struct_Reponse {
	unsigned char TaillePacketReponse;	
	
	unsigned char HeaderLengthIP;
	unsigned char DSF;
	unsigned short TailleTotal;
	unsigned char Id;	
	unsigned short Flags_IP_Offset;
	unsigned char TTL;
	
	unsigned char NumSeq;	
	unsigned char HeaderLengthTCP;
	unsigned char Flags_TCP;
	unsigned short WindowSize;
};


struct struct_Scan_Os {
	gint      Port_Scan;
	gint      Port_Client;
	gint      Id;
	gint      Seq;
	gboolean  Reponse_Scan;
};


struct struct_Smb_Registration {
	unsigned char Type;	
	unsigned char Name[16 + 1];
	unsigned char Numero;
};

struct struct_Smb {
	unsigned char HostName[16 + 1];
	unsigned char DomainName[16 + 1];
	unsigned char Utilisateur[16 + 1];
	struct struct_Smb_Registration Smb_Registration[NUM_MAX_REGISTRATION];
};


struct Struct_Liste_Equipement {
	unsigned char ID_Equipement[MAC_ADDR_LEN + IP_ADDR_LEN + 1];	
	unsigned char Adresse_Ip_Char[15 + 1];	
	unsigned char Adresse_Ip[4 + 1];	
	unsigned char Adresse_MAC_Char[17 + 1];	
	unsigned char Adresse_MAC[6 + 1];	
	gboolean  Scan_Port_En_Cours;	
	gboolean  Intrus;	
	gboolean  Equipement_Restaurer;	
	gboolean  Equipement_Rescanner_En_Cours;	
	gboolean  Equipement_Allumer;	
	time_t    Derniere_Modification_Etat_Equipement;
	gboolean  Notification_Equipement;	
	gint      Compteur_Notification;	
	GList    *GList_Port;	
	gboolean  Scanne_Port_En_Cours;	
	
	gboolean  Scan_Signature;
	struct struct_Reponse Reponse_Signature[NB_SCAN_OS];	
	struct struct_Scan_Os Scan_OS[NB_SCAN_OS];	
	struct struct_Smb Smb;
};

GList    *GList_Equipement;

void      Debug_ID_Equipement (unsigned char *ID_Equipement);
void      Efface_Reponse_Signature (struct Struct_Liste_Equipement *Equipement);
void      Reception_Donnee_Equipement_Connu (struct Struct_Liste_Equipement *Equipement);
void      Equipement_Arreter (struct Struct_Liste_Equipement *Equipement);
void      Affiche_Debug_Liste_Equipement ();
struct Struct_Liste_Equipement *Retour_Pointeur_Equipement (gint Index_Equipement);
gint      Recherche_Index_Equipement (unsigned char *ID_Equipement);
void      Ajout_Equipement (unsigned char *ID_Equipement);
void      Initialisation_Liste_Equipement ();

#endif
