/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include "Notification_Equipement.h"
#include "Debug.h"
#include "Scan_Arp.h"
#include "Semaphore.h"
#include "Com/Initialisation_Com.h"
#include "Com/Commun.h"

void Thread_Notification_Equipement ()
{
	struct Struct_Liste_Equipement *Equipement = NULL;
	struct Struct_Liste_Notification_Equipement *Notification_Equipement = NULL;
	struct struct_Retour_Notification_Changement_Etat_Equipement Message;
	gint      Nb_Objet_Liste, i;

	while (TRUE) {
		i = 0;
		Nb_Objet_Liste = g_list_length (GList_Notification_Equipement);
		while (i < Nb_Objet_Liste) {
			
			sem_wait (&Semaphore_Notification_Equipement);
			Nb_Objet_Liste = g_list_length (GList_Notification_Equipement);	
			if (i < Nb_Objet_Liste) {
				Notification_Equipement = g_list_nth_data (GList_Notification_Equipement, i);
				Equipement = Notification_Equipement->Equipement;
				if (Equipement->Compteur_Notification < TEMP_NOTIFICATION_EQUIPEMENT_CRITIQUE) {
					if (Equipement->Compteur_Notification >= TEMP_NOTIFICATION_EQUIPEMENT_CRITIQUE / 2)	
						Envoie_Arp_Equipement (Equipement);
					Equipement->Compteur_Notification++;
				}
				debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Thread notifie equipement : %s   Compteur : %d", Equipement->Adresse_Ip_Char, Equipement->Compteur_Notification);
				if (Equipement->Compteur_Notification == TEMP_NOTIFICATION_EQUIPEMENT_CRITIQUE) {
					Equipement->Compteur_Notification++;
					debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Notification critique");
					bzero (&Message, sizeof (struct struct_Retour_Notification_Changement_Etat_Equipement));
					Message.ID_Reseau = Info_Demarrage.ID_Reseau;
					memcpy (Message.ID_Equipement, Equipement->ID_Equipement, MAC_ADDR_LEN + IP_ADDR_LEN + 1);
					Communication_Envoie_Donnee (RETOUR_NOTIFICATION_CHANGEMENT_ETAT_EQUIPEMENT, (gpointer *) & Message, sizeof (Message));
				}
			}
			sem_post (&Semaphore_Notification_Equipement);
			i++;
		}
		sleep (1);	
	}
}


void Ajout_Notification_Equipement (gpointer * Donnee)
{
	struct struct_Demande_Notication_Critique_Etat_Equipement *Message = (struct struct_Demande_Notication_Critique_Etat_Equipement *) Donnee;
	struct Struct_Liste_Equipement *Equipement = NULL;
	gint      ID_Equipement;

	ERROR_if (Donnee == NULL);
	ID_Equipement = Recherche_Index_Equipement (Message->ID_Equipement);
	if (ID_Equipement == -1) {
		debug_printf (D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Add (Equipment unknown)");
		return;		
	}
	Equipement = Retour_Pointeur_Equipement (ID_Equipement);
	Ajout_Notification_Equipement_Glist (Equipement);
}

void Enlever_Notification_Equipement (gpointer * Donnee)
{
	struct struct_Annulation_Notification_Etat_Equipement *Message = (struct struct_Annulation_Notification_Etat_Equipement *) Donnee;
	struct Struct_Liste_Equipement *Equipement = NULL;
	gint      ID_Equipement;

	ERROR_if (Donnee == NULL);
	ID_Equipement = Recherche_Index_Equipement (Message->ID_Equipement);
	if (ID_Equipement == -1) {
		debug_printf (D_WARN_USER, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Delete (Equipment unknown)");
		return;		
	}
	Equipement = Retour_Pointeur_Equipement (ID_Equipement);
	Enlever_Notification_Equipement_Glist (Equipement);
}


void Affiche_Debug_Liste_Notification_Equipement_Securiser ()
{
	struct Struct_Liste_Notification_Equipement *Notification_Equipement;
	gint      Nb_Objet_Liste, i;

	sem_wait (&Semaphore_Notification_Equipement);
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "************* Afficher liste notification equipement");
	Nb_Objet_Liste = g_list_length (GList_Notification_Equipement);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Notification_Equipement = g_list_nth_data (GList_Notification_Equipement, i);
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Notification Equipement : %s [%s]", Notification_Equipement->Equipement->Adresse_Ip_Char, Notification_Equipement->Equipement->Adresse_MAC_Char);
	}
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "************* fin");
	sem_post (&Semaphore_Notification_Equipement);
}


struct Struct_Liste_Equipement *Recupere_Pointeur_Notification_Equipement_Dans_Une_Liste (int rang)
{
	return g_list_nth_data (GList_Notification_Equipement, rang);
}


gint Recherche_Index_Notification_Equipement_Non_Securiser (struct Struct_Liste_Equipement * Equipement)
{				
	struct Struct_Liste_Notification_Equipement *Notification_Equipement;
	gint      Nb_Objet_Liste, i;

	ERROR_if (Equipement == NULL);
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Recherche index");
	Nb_Objet_Liste = g_list_length (GList_Notification_Equipement);
	for (i = 0; i < Nb_Objet_Liste; i++) {
		Notification_Equipement = g_list_nth_data (GList_Notification_Equipement, i);
		if (Notification_Equipement->Equipement == Equipement) {
			debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Notification trouve");
			return i;
		}
	}
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "index non trouve");
	return -1;		
}


void Enlever_Notification_Equipement_Glist (struct Struct_Liste_Equipement *Equipement)
{
	gint      ID_Equipement;

	ERROR_if (Equipement == NULL);
	sem_wait (&Semaphore_Notification_Equipement);	
	Equipement->Notification_Equipement = FALSE;	
	if ((ID_Equipement = Recherche_Index_Notification_Equipement_Non_Securiser (Equipement)) != -1)
		GList_Notification_Equipement = g_list_remove (GList_Notification_Equipement, Recupere_Pointeur_Notification_Equipement_Dans_Une_Liste (ID_Equipement));
	else
		debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Enlever Notification Equipement n'existe pas: [%s]", Equipement->Adresse_MAC_Char);
	sem_post (&Semaphore_Notification_Equipement);
	Affiche_Debug_Liste_Notification_Equipement_Securiser ();
}


void Ajout_Notification_Equipement_Glist (struct Struct_Liste_Equipement *Equipement)
{
	struct Struct_Liste_Notification_Equipement *Notification_Equipement;

	ERROR_if (Equipement == NULL);
	debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Ajout notification");
	sem_wait (&Semaphore_Notification_Equipement);	
	Equipement->Notification_Equipement = TRUE;	
	if (Recherche_Index_Notification_Equipement_Non_Securiser (Equipement) == -1) {
		Notification_Equipement = (struct Struct_Liste_Notification_Equipement *) malloc (sizeof (struct Struct_Liste_Notification_Equipement));
		ERROR_if (Notification_Equipement == NULL);
		bzero (Notification_Equipement, sizeof (struct Struct_Liste_Notification_Equipement));	
		Notification_Equipement->Equipement = Equipement;
		Equipement->Compteur_Notification = 0;
		debug_printf (D_INFO, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Nouveau Notification Equipement : %s [%s]", Notification_Equipement->Equipement->Adresse_Ip_Char, Notification_Equipement->Equipement->Adresse_MAC_Char);
		GList_Notification_Equipement = g_list_append (GList_Notification_Equipement, Notification_Equipement);
	}
	else
		debug_printf (D_WARN, __FILE__, __PRETTY_FUNCTION__, __LINE__, "Nouveau Notification Equipement existe deja: [%s]", Equipement->Adresse_MAC_Char);
	sem_post (&Semaphore_Notification_Equipement);
	Affiche_Debug_Liste_Notification_Equipement_Securiser ();
}


void Initialisation_Notification_Equipement ()
{
	GList_Notification_Equipement = NULL;
}
