/*
 *  Copyright (C) 2004-2005 Thierry Lagarde <tlagarde@user.sourceforge.net>
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <semaphore.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include "Socket.h"
#include "Semaphore.h"

int socket_control (int domain, int type, int protocol)
{
	int       Socket;

	if ((Socket = socket (domain, type, protocol)) != -1) {
		sem_wait (&Semaphore_Control_Usage_Socket);
		Nb_Socket_Ouverte++;
		sem_post (&Semaphore_Control_Usage_Socket);
	}
	return Socket;
}


int close_control (int fd)
{
	int       close_s;

	if ((close_s = close (fd)) != -1) {
		sem_wait (&Semaphore_Control_Usage_Socket);
		Nb_Socket_Ouverte--;
		sem_post (&Semaphore_Control_Usage_Socket);
	}
	return close_s;
}
